<?php defined('SYSPATH') OR die('No direct access allowed.');

class Ninja_Auth_Model extends Auth_Model {
    public function __construct() {
        // doesn't call parent
        $this->config = new Config_Model;
        $this->config->read_config();
        if($this->config->conf['auth_enabled'] == 1){
            $this->AUTH_ENABLED = TRUE;
            $this->socketPath = $this->config->conf['livestatus_socket'];
        }
        if (Session::instance()->get('auth_user')) {
            $this->REMOTE_USER = Session::instance()->get('auth_user')->username;
        }
        if($this->AUTH_ENABLED === TRUE && $this->REMOTE_USER === NULL){
		if(!isset($_SERVER['REMOTE_ADDR']) || '127.0.0.1' != $_SERVER['REMOTE_ADDR']) {
			// the request origins from monitor itself, for example the pnp graphs
			// which are retrieved with file_get_contents(uri)
			throw new Kohana_exception("error.remote_user_missing");
		}
        }
    }

    public function is_authorized($host = FALSE, $service = NULL) {
        $access = Session::instance()->get('nagios_access', array());
        if (isset($access['authorized_for_all_hosts']) && $access['authorized_for_all_hosts'] == 1)
            $this->config->conf['allowed_for_all_hosts'] = $this->REMOTE_USER;
        if (isset($access['authorized_for_all_services']) && $access['authorized_for_all_services'] == 1)
            $this->config->conf['allowed_for_all_services'] = $this->REMOTE_USER;
        return parent::is_authorized($host, $service);
    }
}
